-- ========================= flush_ip_net_table.adb ==========================
-- 
--  Copyright 2001 by Craig Spannring
-- 
--  Def:   Remove all entry from the local computer's ARP table on a
--         given interface. 
-- 
-- ===========================================================================



with Ada.Text_IO; use Ada.Text_IO;
with Ada.Wide_Text_Io; 
with Ada.Command_Line;
with Ada.Exceptions;

with Interfaces.C;


with Iphlpapi.thin;    use Iphlpapi.Thin; 
with Iphlpapi.Helpers; use Iphlpapi.Helpers; 

procedure Flush_Ip_Net_Table is 
   rcs_body_revision_id: constant string := "$Header: /home/cts/PersonalRepository/iphlpapi/Attic/flush_ip_net_table.adb,v 1.1.2.2 2001/03/24 04:32:52 cts Exp $";
   
   package Ic   renames Interfaces.C;
   package Wtio renames Ada.Wide_Text_Io;
   package Cl renames Ada.Command_Line;
   
   use type DWORD;
   
   procedure Usage is 
   begin
      Put_Line("Usage- " & Cl.Command_Name & " [interface_index]");
      New_Line;
      Put_Line("  interface is the index of the interface you wish to flush");
   end Usage;
   
   function cvt(Item     : in Ic.wchar_array;
                Trim_Nul : in Boolean := True) return Wide_String
     renames Interfaces.c.To_Ada;
   
   Rc:        Dword;
   Interface: DWORD   := 2;
begin
   if Cl.Argument_Count > 1 then 
      Usage;
      Cl.Set_Exit_Status(Cl.Failure);
      return;
   end if;
   if Cl.Argument_Count >= 1 then 
      Interface := DWORD'Value(Cl.Argument(1));
   end if;
   
   Rc := FlushIpNetTable(Interface);
   
   if Rc = 0 then 
     null;
   else
      Cl.Set_Exit_Status(Cl.Failure);
      Put_Line("Error.  rc = " & DWORD'Image(Rc));
   end if;
exception
   when Exc: others => 
      Put_Line(Ada.Exceptions.Exception_Message(Exc));
      Usage;
      Cl.Set_Exit_Status(Cl.Failure);
end Flush_Ip_Net_Table;
